// Filtre RIF passe-bas 11 coefficients, frequence de coupure fc=1/4 :
exec("TP_1.sce")


//****************************************************
// Signal d'entree
//****************************************************

// generation de sinusoides de frequences f=1/8 et 3/8;
f1=1/8; f2=3/8;
N=64;
n=0:N-1; // n = vecteur de N points, de 0 à N-1
x = cos(2*%pi*f1*n) + cos(2*%pi*f2*n);

// domaine frequentiel
NFFT = 512;
X=fft([x,zeros(1,NFFT-N)],-1);	// spectre sur 512 points par zro-padding,de f = 0 a 1
X=fftshift(X);	// f = -1/2 a +1/2


// Affichage du Spectre d'amplitude
xset("window",2);xbasc(); // selectionne (ou cree) la fenetre 2 et l'efface
f=(-.5:1/NFFT:.5-1/NFFT);   
subplot(211);plot2d(f,20*log10(abs(X/N)),1,"011","",[-0.5 -40 0.5 0]) // NB : normalisation / N
xtitle("Spectre d amplitude de x (en dB)","f","|X(f)| (dB)")


//***************************************
// Signal de sortie du filtre
//***************************************

// filtrage par h
debut_x = cos(2*%pi*f1*(-L+1:-1))+cos(2*%pi*f2*(-L+1:-1)); // initialisation de la convolution
[y,fin_y] = convol(h,x,debut_x); // y = h*x

// Spectre de la sortie
Y=fft([y,zeros(1,NFFT-N)],-1);	// spectre sur 512 points par zro-padding,de f = 0 a 1
Y=fftshift(Y);	// f = -1/2 a +1/2

// Affichage du Spectre d'amplitude
xset("window",2);
subplot(212);plot2d(f,20*log10(abs(Y/N)),1,"011","",[-0.5 -40 0.5 0]) // NB : normalisation / N
xtitle("Spectre d amplitude de y (en dB)","f","|Y(f)| (dB)")

