function [x_debruit] = debruite(x,DAV,opt)

// VARIABLES ET CONSTANTES

N = length(x);

x_debruit = zeros(1,N);

// Parametres d'analyse
rec = 50; // 50% de recouvrement
Nw = 256; // longueur des trames = 256 echantillons (32 ms) 
npts_rec = (1-rec/100)*Nw;
nbloc_rec = fix((N-npts_rec)/(Nw-npts_rec));	// nombre total de blocs a traiter

// Parametres d'estimation spectrale 
nb_trames_silence = 0;
dsp_b = zeros(1,Nw);
lbda = 0.99; 
X = zeros(1,Nw);	// spectre de x
S_est = zeros(1,Nw);	// spectre de l'estimee du signal original
f = (0:128)/256;	// 129 échantillons fréquentiels de 0 a 1/2

// PArametres du gain d'Ephraim et Malah
Beta = 0.98; 
RSBpost = zeros(1,Nw);
RSBprio = zeros(1,Nw);
RSBmin = -5*ones(1,Nw); // Controle du niveau de bruit residuel 
G = zeros(1,Nw);	// Reponse frequentielle

// Parametres du filtre de debruitage (domaine temporel)
if ( (opt==3) | (opt==4) ) then
	L=63;
else
	L = 256;	// longueur du filtre
end;
mem = zeros(1,L-1);	// memoire du filtre (contenu de la ligne a retards)

disp(L,'L=');


// ALGO

index = 1:Nw; // indices de la trame courante

for p = 1:nbloc_rec // p = numero de trame

  X = fft(x(index).*window('hn',Nw),-1);
  
  // Si pas d'activite' vocale, estimation du bruit
  // lbda croit jusqu'a 0.99 
  if (sum(DAV(index)) == 0) then
    nb_trames_silence = min(100,nb_trames_silence+1); 
    lbda = 1-1/nb_trames_silence;
    dsp_b = max(%eps,lbda*dsp_b+(1-lbda)*abs(X).^2);
  end;

  // Debruitage par la methode d'Ephraim et Malah

  RSBpost = (abs(X.^2)./dsp_b)-1;
  RSBprio = Beta * (abs(S_est.^2)./dsp_b) + (1-Beta) * max(0,RSBpost);
  RSBprio = max(RSBprio,10.^(RSBmin/10));
  G = RSBprio./(1+RSBprio);
  S_est = G.*X;

  // Calcul reponse impulsionnelle de longueur L : 
  g = fft(G,1);
  // g = [g(Nw/2+1:Nw),g(1:Nw/2)];
  
  // Question 3a
//  G_ech = 
//  g_ech = 
//  G_ech_256 = 
  
  // Question 3b
//  g_fen = 
//  G_fen = 

  // Affichage a la trame 63
  if (p==63) then 
  		// affichage reponse frequentielle
  		xset("window",0); xbasc();
		 plot2d(f,20*log10(abs(G(1:129))),1); xtitle("trame "+string(p),"f","|G(f)| (dB)")
  		// affichage reponse impulsionnelle
		 xset("window",1); xbasc();
		 plot2d(0:255,g,2,"011","",[-10 -0.1 270 0.6]); xtitle("trame "+string(p),"n","g(n)")
		 // Affichage pour Q 3a :
		 if (opt==3 ) | (opt==4)
       xset("window",2); xbasc(); 
       plot2d(0:62,g_ech,2,"011","",[-10 -0.1 270 0.6]); xtitle("trame "+string(p),"n","g_ech(n)")
       xset("window",0);
       plot2d(f(1:4:129),20*log10(abs(G_ech(1:33))),-9);
       plot2d(f,20*log10(abs(G_ech_256(1:129))),2);
     end;
		 // Affichage pour Q 3b :
		 if (opt==4)
       xset("window",3); xbasc(); 
       plot2d(0:62,g_fen,2,"011","",[-10 -0.1 270 0.6]); xtitle("trame "+string(p),"n","g_fen(n)")
       xset("window",0);
       plot2d(f,20*log10(abs(G_fen(1:129))),5);
     end;
		 
  end;
  
  // Convolution
  select opt,
    case 1 then filtre = g,
    case 2 then filtre = g,
    case 3 then filtre = g_ech,
    case 4 then filtre = g_fen,
  end;
  for i=index(Nw/2+1:Nw)
  	x_debruit(i) = [x(i),mem]*filtre';
  	mem = [x(i),mem(1:L-2)];
  end
  	
 
  index = index+(Nw-npts_rec);

end;

endfunction
